﻿<%@ Page Language="C#" 
    AutoEventWireup="true" Title="Administration" %>
<%@ Import Namespace="System.Data"%>
<%@ Import Namespace="System.Data.SqlClient"%>
<%@ Import Namespace="ChooseYourStory.Utilities"%>
<script runat="server" language="C#">
        protected DataTable Tags = new DataTable();

        private void LoadTags()
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.Connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ChooseYourStory"].ConnectionString);

                cmd.CommandText = "Tags_GetTags";
                cmd.CommandType = CommandType.StoredProcedure;

                try
                {
                    cmd.Connection.Open();
                    Tags.Load(cmd.ExecuteReader());
                }
                finally
                {
                    cmd.Connection.Close();
                }
            }
        }

        private void DeleteTag(string tag)
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.Connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ChooseYourStory"].ConnectionString);

                cmd.CommandText = "Tags_DeleteTag";
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.AddWithValue("@Tag", tag);

                try
                {
                    cmd.Connection.Open();
                    Tags.Load(cmd.ExecuteReader());
                }
                finally
                {
                    cmd.Connection.Close();
                }
            }
        }

        protected void btnAddTag_Click(object sender, EventArgs e)
        {
            if (String.IsNullOrEmpty(txtTag.Text)) return;
            
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.Connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ChooseYourStory"].ConnectionString);

                cmd.CommandText = "Tags_AddTag";
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.AddWithValue("@Tag", txtTag.Text);

                try
                {
                    cmd.Connection.Open();
                    Tags.Load(cmd.ExecuteReader());
                }
                finally
                {
                    cmd.Connection.Close();
                }
            }

            Response.Redirect("Tags.aspx");
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!String.IsNullOrEmpty(Request.QueryString["delete"]))
            {
                string tag = Request.QueryString["delete"];
                if (!String.IsNullOrEmpty(tag)) DeleteTag(tag);
            }
            
            LoadTags();

            if (!Page.IsPostBack)
            {
                rptTag.DataSource = Tags;
                rptTag.DataBind();
            }
        }

</script> 
<asp:Content ID="Content1" ContentPlaceHolderID="HeaderContentPlaceHolder" Runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="MainContentPlaceHolder" Runat="Server">

    <h1>Administration &raquo; Tags</h1>
    
    <asp:Repeater ID="rptTag" runat="server">
        <HeaderTemplate>
            <table>
                <tr>
                    <th align="left">Tag</th>
                    <th align="left">Tag Count</th>
                    <th>&nbsp;</th>
                </tr>
        </HeaderTemplate>
        
        <ItemTemplate>
            <tr>
                <td><%#Eval("Tag") %></td>
                <td><%#Eval("Tag Count") %></td>
                <td><a onclick="return confirm('Are you sure?')" href="Tags.aspx?delete=<%#Eval("Tag") %>">[Delete]</a></td>
            </tr>
        </ItemTemplate>
        
        <AlternatingItemTemplate>
            <tr style="background:#EAEAEA;">
                <td><%#Eval("Tag") %></td>
                <td><%#Eval("Tag Count") %></td>
                <td><a onclick="return confirm('Are you sure?')" href="Tags.aspx?delete=<%#Eval("Tag") %>">[Delete]</a></td>
            </tr>
        </AlternatingItemTemplate>
        
        <FooterTemplate></table></FooterTemplate>
    </asp:Repeater>
    
<form runat="server">
    <strong>Add Tag:</strong> 
    <asp:TextBox runat="server" ID="txtTag" /> 
    <asp:Button runat="server" ID="btnAddTag" OnClick="btnAddTag_Click" Text="Add Tag" />
</form>

</asp:Content>

